<?php

namespace Drupal\recurly_aegir\Provisioners;

use Drupal\user\Entity\User;
use Drupal\recurly_aegir\Provisioners\RecurlyAegirSiteCreateProvisioner;

/**
 * Class for cloning new sites via Aegir's Web service API.
 */
class RecurlyAegirSiteCloneProvisioner extends RecurlyAegirSiteCreateProvisioner {

  /**
   * The human-readable task type used by this privisioner.
   */
  const TASK_TYPE = 'Clone';

  /**
   * {@inheritdoc}
   *
   * Provisions new sites via clone tasks.
   */
  public function provision() {
    $this->sendRequestAndReceiveResponse('task', [
      // Task type.
      'type' => strtolower($this->getTaskType()),
      // Source.
      'target' => $this->template,
      'options' => [
        // Destination.
        'new_uri' => $this->hostname,
        // Client username.
        'client_name' => $this->client->getDisplayName(),
        // Client e-mail address.
        'client_email' => $this->client->getEmail(),
      ],
    ]);

    return $this;
  }

}
