<?php

namespace Drupal\recurly_aegir\Provisioners;

use Drupal\recurly_aegir\Provisioners\RecurlyAegirSiteProvisioner;

/**
 * Base class for deleting new sites via Aegir's Web service API.
 */
class RecurlyAegirSiteDeleteProvisioner extends RecurlyAegirSiteProvisioner {

  /**
   * The human-readable task type used by this provisioner.
   */
  const TASK_TYPE = 'Delete';

  /**
   * {@inheritdoc}
   */
  public static function getTaskType() {
    return self::TASK_TYPE;
  }

  /**
   * {@inheritdoc}
   *
   * Deletes a site.
   */
  public function provision() {
    $this->sendRequestAndReceiveResponse('task', [
      // Task type.
      'type' => strtolower($this->getTaskType()),
      // Site to delete.
      'target' => $this->hostname . '.' . \Drupal::request()->getHost(),
    ]);

    return $this;
  }

}
