<?php

namespace Drupal\recurly_aegir\Provisioners;

use Drupal\recurly_aegir\Provisioners\RecurlyAegirSiteProvisioner;

/**
 * Fetches the list of sites via Aegir's Web service API.
 */
class RecurlyAegirSiteListProvisioner extends RecurlyAegirSiteProvisioner {

  /**
   * The human-readable task type used by this provisioner.
   */
  const TASK_TYPE = 'List';

  /**
   * {@inheritdoc}
   */
  public static function getTaskType() {
    return self::TASK_TYPE;
  }

  /**
   * {@inheritdoc}
   *
   * Returns the list of existing sites.
   */
  public function provision() {
    $this->sendRequestAndReceiveResponse('site.json', []);
    return $this;
  }

  public function getSiteList() {
    return $this->response;
  }
}
